<?php

namespace DoctrineORMModule\Proxy\__CG__\RADAR\Entity;

/**
 * DO NOT EDIT THIS FILE - IT WAS CREATED BY DOCTRINE'S PROXY GENERATOR
 */
class TbRadarArea extends \RADAR\Entity\TbRadarArea implements \Doctrine\ORM\Proxy\Proxy
{
    /**
     * @var \Closure the callback responsible for loading properties in the proxy object. This callback is called with
     *      three parameters, being respectively the proxy object to be initialized, the method that triggered the
     *      initialization process and an array of ordered parameters that were passed to that method.
     *
     * @see \Doctrine\Common\Persistence\Proxy::__setInitializer
     */
    public $__initializer__;

    /**
     * @var \Closure the callback responsible of loading properties that need to be copied in the cloned object
     *
     * @see \Doctrine\Common\Persistence\Proxy::__setCloner
     */
    public $__cloner__;

    /**
     * @var boolean flag indicating if this object was already initialized
     *
     * @see \Doctrine\Common\Persistence\Proxy::__isInitialized
     */
    public $__isInitialized__ = false;

    /**
     * @var array properties to be lazy loaded, with keys being the property
     *            names and values being their default values
     *
     * @see \Doctrine\Common\Persistence\Proxy::__getLazyProperties
     */
    public static $lazyPropertiesDefaults = [];



    /**
     * @param \Closure $initializer
     * @param \Closure $cloner
     */
    public function __construct($initializer = null, $cloner = null)
    {

        $this->__initializer__ = $initializer;
        $this->__cloner__      = $cloner;
    }







    /**
     * 
     * @return array
     */
    public function __sleep()
    {
        if ($this->__isInitialized__) {
            return ['__isInitialized__', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'coArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'noArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'sgArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'dsArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'dtCriacao', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'stAtivo', 'usuarios'];
        }

        return ['__isInitialized__', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'coArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'noArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'sgArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'dsArea', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'dtCriacao', '' . "\0" . 'RADAR\\Entity\\TbRadarArea' . "\0" . 'stAtivo', 'usuarios'];
    }

    /**
     * 
     */
    public function __wakeup()
    {
        if ( ! $this->__isInitialized__) {
            $this->__initializer__ = function (TbRadarArea $proxy) {
                $proxy->__setInitializer(null);
                $proxy->__setCloner(null);

                $existingProperties = get_object_vars($proxy);

                foreach ($proxy->__getLazyProperties() as $property => $defaultValue) {
                    if ( ! array_key_exists($property, $existingProperties)) {
                        $proxy->$property = $defaultValue;
                    }
                }
            };

        }
    }

    /**
     * 
     */
    public function __clone()
    {
        $this->__cloner__ && $this->__cloner__->__invoke($this, '__clone', []);
    }

    /**
     * Forces initialization of the proxy
     */
    public function __load()
    {
        $this->__initializer__ && $this->__initializer__->__invoke($this, '__load', []);
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     */
    public function __isInitialized()
    {
        return $this->__isInitialized__;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     */
    public function __setInitialized($initialized)
    {
        $this->__isInitialized__ = $initialized;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     */
    public function __setInitializer(\Closure $initializer = null)
    {
        $this->__initializer__ = $initializer;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     */
    public function __getInitializer()
    {
        return $this->__initializer__;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     */
    public function __setCloner(\Closure $cloner = null)
    {
        $this->__cloner__ = $cloner;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific cloning logic
     */
    public function __getCloner()
    {
        return $this->__cloner__;
    }

    /**
     * {@inheritDoc}
     * @internal generated method: use only when explicitly handling proxy specific loading logic
     * @static
     */
    public function __getLazyProperties()
    {
        return self::$lazyPropertiesDefaults;
    }

    
    /**
     * {@inheritDoc}
     */
    public function getCoArea()
    {
        if ($this->__isInitialized__ === false) {
            return (int)  parent::getCoArea();
        }


        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getCoArea', []);

        return parent::getCoArea();
    }

    /**
     * {@inheritDoc}
     */
    public function setCoArea($coArea)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setCoArea', [$coArea]);

        return parent::setCoArea($coArea);
    }

    /**
     * {@inheritDoc}
     */
    public function getNoArea()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getNoArea', []);

        return parent::getNoArea();
    }

    /**
     * {@inheritDoc}
     */
    public function setNoArea($noArea)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setNoArea', [$noArea]);

        return parent::setNoArea($noArea);
    }

    /**
     * {@inheritDoc}
     */
    public function getDsArea()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getDsArea', []);

        return parent::getDsArea();
    }

    /**
     * {@inheritDoc}
     */
    public function setDsArea($dsArea)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setDsArea', [$dsArea]);

        return parent::setDsArea($dsArea);
    }

    /**
     * {@inheritDoc}
     */
    public function getStAtivo()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getStAtivo', []);

        return parent::getStAtivo();
    }

    /**
     * {@inheritDoc}
     */
    public function setStAtivo($stAtivo)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setStAtivo', [$stAtivo]);

        return parent::setStAtivo($stAtivo);
    }

    /**
     * {@inheritDoc}
     */
    public function getSgArea()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getSgArea', []);

        return parent::getSgArea();
    }

    /**
     * {@inheritDoc}
     */
    public function setSgArea($sgArea)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setSgArea', [$sgArea]);

        return parent::setSgArea($sgArea);
    }

    /**
     * {@inheritDoc}
     */
    public function getDtCriacao()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getDtCriacao', []);

        return parent::getDtCriacao();
    }

    /**
     * {@inheritDoc}
     */
    public function setDtCriacao($dtCriacao)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setDtCriacao', [$dtCriacao]);

        return parent::setDtCriacao($dtCriacao);
    }

    /**
     * {@inheritDoc}
     */
    public function getUsuarios()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'getUsuarios', []);

        return parent::getUsuarios();
    }

    /**
     * {@inheritDoc}
     */
    public function setData($data)
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'setData', [$data]);

        return parent::setData($data);
    }

    /**
     * {@inheritDoc}
     */
    public function toArray()
    {

        $this->__initializer__ && $this->__initializer__->__invoke($this, 'toArray', []);

        return parent::toArray();
    }

}
